!     SLSQP Main

	INTEGER LEN_W, LEN_JW, M, N, N1, MEQ, MINEQ
	PARAMETER (M=0, MEQ=0, N=5)
      PARAMETER (N1= N+1, MINEQ= M-MEQ+N1+N1)
      PARAMETER (LEN_W=
     $           (3*N1+M)*(N1+1)
     $          +(N1-MEQ+1)*(MINEQ+2) + 2*MINEQ
     $          +(N1+MINEQ)*(N1-MEQ) + 2*MEQ + N1
     $          +(N+1)*N/2 + 2*M + 3*N + 3*N1 + 1,
     $           LEN_JW=MINEQ)
      
	DOUBLE PRECISION W(LEN_W),X(5),f,xl(5),xu(5)
	DOUBLE PRECISION G(5),ACC
      INTEGER JW(LEN_JW),LA,ITER,MODE
	INTEGER I1,I2

	DOUBLE PRECISION YDATA(2,200)
	INTEGER NOBS,NN

	open(unit=76, file='Voltage data.txt')
	read(76,*) NOBS
	DO K=1,NOBS
		read(76,*) YDATA(1,K),YDATA(2,k)
	ENDDO

	close(76) 

	LA=MAX(M,1)	!LA .GE. MAX(M,1)
!	Read the bounds for your optimizing variables
	open (unit=61,file="bounds.txt")
	read(61,*) NN
	do i1 = 1,NN
	read(61,*) xl(i1),xu(i1)
	enddo
	close(61)
!	Read the initial gues for your optimizing variables
	open (unit=62,file="guess.txt")
	do i2 = 1,NN
	read(62,*) x(i2)
	enddo
	close(62)

	call estimate(x,nn,nobs,YDATA,f)
	call my_grad(x,xl,xu,f,nn,nobs,YDATA,G)

	ACC = 1.d-9
	iter = 1000

	write(*,*)"                                         "
	write(*,*)"@All rights reserved. Academic purpose only."
	write(*,*)"                                         "
      write(*,*)"-Indian Institute of Technology Hyderabad-"
	write(*,*)"Prof.Kishalay Mitra (kishalay@iith.ac.in)"
	write(*,*)"                                         "
	write(*,*)"-University of Washington, Seattle-"
	write(*,*)"Seong Beom Lee (seongl2@uw.edu)"
	write(*,*)"Prof.Venkat R. Subramanian (vsubram@uw.edu)"
	write(*,*) "                                         "

	do while (1)

		CALL slsqp (m, meq, la, n, x, xl, xu, f, c, g, a,
     *                  acc, iter, mode, w, len_w, jw, len_jw)

		
		write(*,*) "Mode :", mode
		select case(mode)
		case (-1)  
			write(*,*) "Numerical Gradient is supplied" 
			call estimate(x,nn,nobs,YDATA,f)
			call my_grad(x,xl,xu,f,nn,nobs,YDATA,G)
			write(*,*)"Objective Function", f
		case (-2)
			call estimate(x,nn,nobs,YDATA,f)
			call my_grad(x,xl,xu,f,nn,nobs,YDATA,G)
			write(*,*)"Objective Function", f
		case (1)
			call estimate(x,nn,nobs,YDATA,f)
			call my_grad(x,xl,xu,f,nn,nobs,YDATA,G)
			write(*,*)"Objective Function", f
		case (0) !required accuracy for solution obtained 
			go to 30

		End Select
	enddo
      
   30	write(*,*) "                        " 
   	write(*,*) "Optimal solution found: " 
	call estimate(x,nn,nobs,YDATA,f)
	call my_grad(x,xl,xu,f,nn,nobs,YDATA,G)
	write(*,*) "                        "
	write(*,*) "Objective Function: ", f
	write(*,*) "                        "
	write(*,*) "Optimized Variables: "
!	do ii = 1,5
!		write(*,*) x(ii)
!	enddo

      write(*,*) "Rate constant at anode:", exp(-x(1))
      write(*,*) "Rate constant at cathode:",exp(-x(2))
      write(*,*) "Formal potential:",x(3)
      write(*,*) "Diffusion coefficient of protons:",exp(-x(4))
      write(*,*) "Cell resistance excluding the membrane:",x(5)

	open(unit=12, file="Estimated parameters.csv")
	write(12,*) "Objective Function: ", f
	write(12,*) "Optimized Variables: "

      write(12,*) "Rate constant at anode:", exp(-x(1))
      write(12,*) "Rate constant at cathode:",exp(-x(2))
      write(12,*) "Formal potential:",x(3)
      write(12,*) "Diffusion coefficient of protons:",exp(-x(4))
      write(12,*) "Cell resistance excluding the membrane:",x(5)

!	do ii = 1,5
!       write(*,*) x(ii)
!	enddo
	close(12)

	stop
	end