!     Simulation for CC charging

	subroutine Reaction1(NPAR1,XRpar,IDID,YMO,YMO1,YMO2,NOBS)
	USE NUMERICAL_LIBRARIES
	IMPLICIT REAL*8(A-H,O-Z)

	common/input11/Node,Nae,Neq
	common/iapprel/iapp
	common/err/rtol1,atol1,RTOL2,ATOL2,dtout0,dtout01,
	1nout
	Double precision Rpar(NPAR1),XRpar(NPAR1)
	integer NPAR1,IDID
!	real XRpar(NPAR1)

	DOUBLE PRECISION DTOUT0,DTOUT01,ATOL1,RTOL1,
	1ATOL2,RTOL2
	DOUBLE PRECISION TDAT(NOBS),YMO(7,NOBS),YMO1(7,NOBS),YMO2(7,NOBS)
	DOUBLE PRECISION iapp
	
	INTEGER Node,Nae,Neq,nout

	Do i = 1, NPAR1
	Rpar(i) = XRpar(i)
	Enddo

	OPEN(UNIT=4,FILE='daskrinput.txt')  ! Input File 1
	Read (4,*) NODE
	Read (4,*) NAE
	Read (4,*) RTOL1
	Read (4,*) ATOL1
	CLOSE(4)

	OPEN(UNIT=41,FILE='Experimental conditions.txt')  ! Input File 1
	Read (41,*) iapp
	Read (41,*) DTOUT0
	Read (41,*) DTOUT01
	Read (41,*) NOUT
	CLOSE(41)

	NEQ = NODE+NAE
	NRT=1	
      LRW = 2*(60+10*NEQ+NEQ**2 +3*NRT)
	LIW=40+3*NEQ

 	RTOL2=rtol1
	ATOL2=atol1 

	CALL DRIVE (MAXORD,LRW,LIW,NRT,RPAR,IDID,TDAT,YMO,NOBS)

      CALL DRIVE1 (MAXORD,LRW,LIW,NRT,RPAR,IDID,TDAT,YMO1,NOBS)

	CALL DRIVE11 (MAXORD,LRW,LIW,NRT,RPAR,IDID,TDAT,YMO2,NOBS)
	 
	return
	END

	SUBROUTINE DRIVE (MAXORD,LRW1,LIW1,NRT1,RPAR,IDID,TDAT,YMO,NOBS)
	INTEGER NEQ,MAXORD,LRW1,LIW1,IRES,iremt,IPAR(1),INFO(30),
	1 IWK(LIW1),NRT1
	integer jroot(NRT1)

	DOUBLE PRECISION Y(NEQ),YPRIME(NEQ),DELTA(NEQ),ATOL(NEQ),
	1 RTOL(NEQ),DTOUT,dtout1,DTOUT0,DTOUT01,ATOL1,
     2RTOL1,ATOL2
	DOUBLE PRECISION TDAT(NOBS),YMO(7,NOBS),RTOL2,iapp
	DOUBLE PRECISION   T, TOUT, RWORK(LRW1),RPAR(23)
	INTEGER IWORK(LIW1),SENPAR
	
	common/input11/Node,Nae,Neq
	common/iapprel/iapp
	common/err/rtol1,atol1,RTOL2,ATOL2,dtout0,dtout01,
	1nout

	EXTERNAL  DRES1, DJAC1, RTX2, IC1s

      t=0.d0

	DO 115 I = 1,30
115	INFO(I) = 0

	INFO(2)=1
	DO ITOL=1,Node
	ATOL(ITOL)=ATOL1
	RTOL(ITOL)=RTOL1
	ENDDO

	DO ITOL=Node+1,NEQ
 	ATOL(ITOL)=ATOL2
 	RTOL(ITOL)=RTOL2
	ENDDO

	INFO(8)=1
	Rwork(3)=1.0D-2

	do i=1,Neq
	iwork(40+i)=2
	enddo

	do i=Node+1,Neq
	iwork(40+i)=-1
	enddo

	INFO(11)=1

	CALL IC1s(Y,RPAR)
	
	do i=1,NEQ
	YPRIME(i)=1
	enddo

	call DRES1(T,Y,YPRIME,cj,DELTA,IRES,RPAR,IPAR,SENPAR)
	
	CALL RESULTS(T,Y,YPRIME,DELTA)	

	Tout=0.D0

	DO 125 I = 1,NOUT
	
	tout=tout+DTOUT0
	
120	CALL DDASKR (DRES1, NEQ, T, Y, YPRIME, TOUT, INFO, RTOL, ATOL,
     1   IDID, RWORK, LRW1, IWORK, LIW1, RPAR, IPAR, DJAC1, PSOL,
	2   SENPAR, G_RES, K_RES, T_RES, A_RES,
     3   RTX2, NRT1, JROOT)

	YMO(1,I)=Y(1)
	YMO(2,I)=Y(2)
	YMO(3,I)=Y(3)
	YMO(4,I)=Y(4)
	YMO(5,I)=Y(5)
      YMO(6,I)=Y(6)
	YMO(7,I)=Y(7)
	
	OPEN(UNIT=19,FILE="ICsCV.txt")
	Write(19,*) YMO(1,I),YMO(2,I),YMO(3,I),YMO(4,I),YMO(5,I),YMO(6,I),
	1iapp
      CLOSE(19)
	

	CALL RESULTS(T,Y,YPRIME,DELTA)

	IF (IDID .EQ. 5) GOTO 181
	IF (IDID .LT. 1) GOTO 179

125	CONTINUE
127	FORMAT(1(F))		
	
	return

179	WRITE(*,*) IDID
180	FORMAT(//1X,'Simulation Failed',/)
	CLOSE(2)


181	return

	END


	SUBROUTINE RESULTS(T,Y,YPRIME,DELTA)
!===========================================================================================================
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	DIMENSION Y(*),YPRIME(*),DELTA(*)
	common/input11/Node,Nae,Neq

	Integer neq1

	neq1 = neq+1

420	FORMAT(1X,<NEQ1>(F13.8))

	RETURN
	END


	SUBROUTINE RTX2(NEQ, T, Y, YP, NRT, RVAL, RPAR, IPAR)
!=================================================================================================
	IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION Y(*), YP(*), RVAL(NRT)

	RVAL(1)=Y(7)-1.7      ! Cutoff voltage for charging
 
	RETURN
	END


	SUBROUTINE DJAC1(T,Y,YPRIME,PD,CJ,RPAR,IPAR,SENPAR)
!===============================================================================================================
      IMPLICIT NONE
      INTEGER IPAR(*)
      DOUBLE PRECISION T,Y(*),YPRIME(*),PD(*),CJ,RPAR(*),SENPAR

	
	RETURN
	END  